# A Url Shortener with QR-Code

This is a experimental Project aimed at getting my BDD and Feature injection Skills up. Right now in early Stages. Goal was to create a url shorteneer, much alike to tools like tinyurl
and add a feature that displays the links as QR Codes. It is not pretty, it is not very secure and not a stable tool for production.
However it should demonstrate how express.js and the toolchain that is coming along with it works.

# Required tools

## Node.js

Node.js is a platform built on Chrome's JavaScript runtime for easily building fast, scalable network applications. Node.js uses an event-driven, non-blocking I/O model that makes it lightweight and efficient, perfect for data-intensive real-time applications that run across distributed devices.

[http://nodejs.org]

## Cucumber.js

Cucumber, the popular Behaviour-Driven Development tool, brought to your JavaScript stack.

It runs on both Node.js and modern web browsers.

Try it now: [http://cucumber.no.de]!

## Grunt.js

Grunt is a task-based command line build tool for JavaScript projects.

[https://github.com/cowboy/grunt]

## Mocha

Mocha is a feature-rich JavaScript test framework running on node and the browser, making asynchronous testing simple and fun. Mocha tests run serially, allowing for flexible and accurate reporting, while mapping uncaught exceptions to the correct test cases.

[http://visionmedia.github.com/mocha/]

## Redis Key-Value Storage

Redis is an open source, advanced key-value store. It is often referred to as a data structure server since keys can contain strings, hashes, lists, sets and sorted sets.

[http://redis.io/]

# Installation

After you installed node.js and Redis

```
sudo npm install -g mocha
sudo npm install -g grunt
sudo npm install -g cucumber
npm install
npm install zombie
npm install grunt-exec
npm install
```

Start your redis server

## Node Modules

All this modules will be installed automatically by npm with the given package.json

```
npm install
```

 * Express.js
 * Jade templating Engine
 * zlib and bases - for sha1 and other hashing mechanisms
 * redis url A Driver for redis


# Tests

## All Tests

 * Start Redis
 * Start the application via ```node app.js```
 * Run all grunt Tests ```grunt```


```
yori:shortener sebastian$ grunt
Running "exec:flushdb" (exec) task
db empty

Running "exec:mocha" (exec) task

  ․․․․․․․․․․․

  ✔ 11 tests complete (11ms)


Running "exec:cucumber" (exec) task
........................................

12 scenarios (12 passed)
40 steps (40 passed)

Running "lint:files" (lint) task
Lint free.

Done, without errors.
```

Remark: As bad as it sounds: The Unit- and Cucumber-Tests require a Database. You might wanna run ```node flushdb.js``` before running mocha tests.

## Mocha

```
node flushdb.js
mocha
```

## cucumber.js

```
node flushdb.js
cucumber.js
```

##JSLint

```
grunt lint
```





