var shortenUrlWrapper = function () {
  this.World = require("../support/world.js").World; // overwrite default World constructor

  this.Given(/^I am on shrtnrqr site$/, function (callback) {
    this.visit('http://localhost:5000/', callback);
  });

  this.When(/^I go to the url "([^"]*)"$/, function(arg1, callback) {
    this.visit(arg1, callback);
  });

  this.When(/^I go to homepage$/, function (callback) {
    this.visit('http://localhost:5000/', callback);
  });

  this.Then(/^I should see "(.*)" as the page title$/, function (title, callback) {
    var pageTitle = this.browser.text('title');
    if (title === pageTitle) {
      callback();
    } else {
      callback.fail(new Error("Expected to be on page with title " + title + " but found " + pageTitle));
    }
  });

  this.Then(/^I should see a Button named "([^"]*)"$/, function (button, callback) {
    if (typeof this.browser.button(button) === 'undefined') {
      callback.fail(new Error("Expected submit button with Text " + button));
    } else {
      callback();
    }
  });

  this.When(/^I enter "([^"]*)" into the input field and hit the "([^"]*)" button$/, function(arg1, arg2, callback) {
    var browser = this.browser;
    this.browser.fill('url', arg1);
    this.browser.pressButton(arg2, function (err) {
      browser.wait(300).then(function (e) {
        callback();
        // console.log(browser.error);
      });
    });
  });

  this.Then(/^I should get a internal server error$/, function(callback) {
    // express the regexp above with the code you wish you had
    var internalServerErrorMsg = "Error: Server returned status code 500";

    if (this.browser.error.toString() === internalServerErrorMsg) {
      callback();
    } else {
      callback.fail(new Error("The browser did not answer with a internal Server errror but " + this.browser.error));
    }
  });

  this.Then(/^The url should get shortened$/, function (callback) {
    var find = this.browser.text('body').search('resulted in a shorturl');

    if (find < 0) {
      callback.fail(new Error("No shortened url in page"));
    } else {
      callback();
    }
  });
};

module.exports = shortenUrlWrapper;