/*global module:false*/
module.exports = function (grunt) {

  // Project configuration.
  grunt.initConfig({
    lint:{
      files:['grunt.js',
        'lib/short/index.js',
        'lib/storage/index.js',
        'routes/validate/index.js',
        'routes/index/index.js',
        'lib/stats/index.js',
        'features/step_definitions/*.js',
        'features/support/*.js',
        'test/*.js',
        'app.js'
      ]
    },
    watch:{
      files:'<config:lint.files>',
      tasks:'lint'
    },
    jshint:{
      options:{
        curly:true,
        eqeqeq:true,
        immed:true,
        latedef:true,
        newcap:true,
        noarg:true,
        sub:true,
        undef:true,
        boss:true,
        eqnull:true,
        browser:true,
        multistr:true,
        onecase:true,
        es5:true
      },
      globals:{
        console: true,
        alert:false,
        require:true,
        describe: true,
        it: true,
        exports: true,
        module: true,
        process: true,
        __dirname: true
      }
    },
    exec: {
      flushdb: {
        command: 'node flushdb.js',
        stdout: true
      },
      mocha: {
        command: 'mocha',
        stdout: true
      },
      cucumber: {
        command: 'cucumber.js',
        stdout: true
      }
    }
  });

  // Default task.
  grunt.loadNpmTasks('grunt-exec');
  grunt.registerTask('default', 'exec lint');
  // grunt.registerTask('default', 'exec');


};
