var crypto = require('crypto')
  , shasum = crypto.createHash('sha1'),
  redis = require('redis-url').connect(process.env.REDISTOGO_URL);

exports.urlToHash = function(url, hash, cb) {
  shasum = crypto.createHash('sha1');
  shasum.update(url);
  var sha1hash = shasum.digest('hex');
  redis.sadd(sha1hash, hash, function(err, res) {
    if (cb) {
      cb(res);
    }
  });
};

exports.hashes = function(url, cb) {
  shasum = crypto.createHash('sha1');
  shasum.update(url);
  var sha1hash = shasum.digest('hex');
  redis.smembers(sha1hash, function(err, res) {
    cb(res);
  });
};

