var redis = require('redis-url').connect(process.env.REDISTOGO_URL);

exports.count = function(hash, userAgent, cb) {
  // count hit allover for hash
  redis.hincrby('stats:hash:'+hash, 'total', 1);
  // count daily for hash
  var date = new Date();
  var today = date.getDay()+':'+date.getMonth()+':'+date.getFullYear();
  redis.hincrby('stats:hash:'+hash, today, 1);
  // count browser for hash
  redis.hincrby('stats:agent:'+hash, userAgent, 1);
  if (cb) {
    cb();
  }
};

exports.get = function(hash, cb) {
  var res;
  redis.hgetall('stats:hash:'+hash, function(err, redisRes) {
    res = redisRes;
    redis.hgetall('stats:agents:'+hash, function(err, redisRes) {
      res.agents = redisRes;
      cb(res);
    });
  });
};
