var redis = require('redis-url').connect(process.env.REDISTOGO_URL),
    shortener = require('../short');

exports.create = function(url, alias, cb) {
  redis.incr('urlcounter', function(err, redisRes) {
    var hash = (typeof alias !== 'undefined' && alias !== null && alias !== "") ? alias : shortener.encode(redisRes);

    var data =  {
      hash: hash,
      url: url,
      added: new Date()
    };

    redis.hmset('id:' + hash, data);

    if (cb) {
      cb(data);
    }
  });
};

exports.read = function(hash, cb) {
  redis.hgetall('id:'+hash, function(err, redisRes) {
    cb(redisRes);
  });
};




