var shortener = require('../../lib/short'),
  storage = require('../../lib/storage'),
  stats = require('../../lib/stats'),
  url = require('url'),
  os = require('os'),
  redis = require('redis-url').connect(process.env.REDISTOGO_URL);

module.exports = function (app) {
  return {
    'index': function(req, res, next) {
      res.render('index', { title:'QRSHORTNR' });
    },
    'new': function(req, res, next) {
      var url = req.body.url;
      var alias = req.body.alias;
      storage.create(url, alias, function (redisRes) {
        // do that call to avoid errors
        stats.count(redisRes.hash, 'shortnener');
        res.render('new', {
          title:'New',
          url:redisRes.url,
          hash:redisRes.hash
        });
      });
    },
    'details': function(req, res, next) {
      var hash = req.params.hash;
      storage.read(hash, function (redisRes) {

        if (redisRes.url.search('http://') === -1 && redisRes.url.search('://') === -1) {
          redisRes.url = 'http://' + redisRes.url;
        }
        stats.get(hash, function(statsRes) {
          res.render('details', { title:'Details', hash:hash, url:redisRes.url, stats: statsRes });
        });
      });
    },
    'link': function(req, res, next) {
      var hash = req.params.hash;

      storage.read(hash, function (redisRes) {
        if (redisRes.url.search('http://') === -1 && redisRes.url.search('://') === -1) {
          redisRes.url = 'http://' + redisRes.url;
        }
        var userAgent = req.headers['user-agent'];
        stats.count(hash, userAgent);
        res.redirect(redisRes.url, 301);
      });
    }
  };
};
