var urlHelper = require('url');

module.exports = function (app) {
  return {
    csrf:function (req, res, next) {
      if (app.settings.env === 'development') {
        next();
        return;
      }

      if (req.session._csrf !== req.body._csrf) {
        res.send(500, { error:'something blew up' });
        return;
      }
      next();
    },
    url:function (req, res, next) {

      if (typeof req.body.url === 'undefined') {
        next(new Error('No Url Given'));
        return;
      }

      var url = req.body.url;

      if (url.length < 4 || url.length > 2000) {
        next(new Error('Url length Error'));
        return;
      }

      var allowed = {
        'http:':true,
        'ftp:':true
      };

      var parsed = urlHelper.parse(url, false);

      if (!parsed.protocol || parsed.protocol === '') {
        next();
        return;
      }
      if (typeof allowed[parsed.protocol] === 'undefined') {
        next(new Error('Only http:// and ftp:// allowed'));
        return;
      }

      next();
    }
  };
};
