var assert = require("assert");
var map = require("../lib/map");
describe('map', function () {
  it('should map a hashes to a url only one time', function(done) {
    map.urlToHash('http://chip.de', 'foo', function(res) {
      assert.equal(res, 1);
      // second call no mapping so a 0 as result
      map.urlToHash('http://chip.de', 'foo', function(res) {
        assert.equal(res, 0);
        done();
      });
    });
  });
  it('should retrieve the hashes for a given url', function(done) {
    map.urlToHash('http://wikipedia.de', 'bar', function(res) {
      map.urlToHash('http://wikipedia.de', 'baz', function(res) {
        map.hashes('http://wikipedia.de', function(res) {
          assert.equal(typeof res, 'object');
          assert.equal(res[0], 'baz');
          assert.equal(res.length, 2);

          done();
        });
      });
    });
  });
});