var assert = require("assert");
var storage = require("../lib/storage");
describe('storage', function () {
  describe('structure', function () {
    it('should be a object', function () {
      assert.equal(typeof storage, 'object');
    });
    it('should have the methods', function () {
      assert.equal(typeof storage.read, 'function');
      assert.equal(typeof storage.create, 'function');
    });
  });

  describe('create and read', function () {
    it('should store without a error if only url', function (done) {
      var url = 'http://wikipedia.de';
      storage.create(url, undefined, function (res) {
        assert.equal(res.url, 'http://wikipedia.de');
        assert.notEqual(res.hash, '');
        assert.equal(res.hash, 'b');
        assert.notEqual(res.added, '');

        storage.read(res.hash, function(res2) {

          assert.equal(res.url, res2.url);
          assert.equal(res.added, res2.added);
          assert.equal(res.hash, res2.hash);


          done();
        });


      });
    });
  });
});
